function [like,flag] = like(ad,eta,approx,dim,data,para,filter,N)
% Evaluate the likelihood through particle filtering
[nd,ra,pia,gamq,neta,nsig] = ndrv(para,ad,eta,approx);
[pf,flag] = polappx(nd,neta,approx);

if flag ~= 1
    like = -Inf;
else
   sysm = sysmat(pf,ra,pia,gamq,neta,nsig);
   if approx == 1
       like = filter_kalman(sysm);
   elseif approx == 2 
       switch filter
           case 1 % Central difference Kalman filter
               like = filter_cdkf(sysm,dim);   
           case 2 % Bootstrap filter;
               like = filter_bf(sysm,dim,data,N); 
           case 3 % Conditional particle filter
               like = filter_cpf(sysm,dim,data,N); 
           case 4 % Central difference particle filter
               like = filter_cdpf(sysm,dim,data,N); 
           case 5 % Auxiliary particle filter 1
               like = filter_apf(sysm,dim,data,N);          
       end
   end
end
end