function [] = mcmc_rwm(para_mode,sig_r,ad,eta,approx,dim,data,filter,N,c,T,Tb)
% Random-walk Metropolis               
     
Np = length(para_mode);
parax = trans(para_mode);
parax_inv = para_mode;
objx = like(ad,eta,approx,dim,data,parax_inv,filter,N) + prior(parax_inv) + log(obj_jacob(parax_inv));

para_inv = zeros(Np,T+Tb);
obj = 1:T+Tb;
accept = 1:T+Tb;
count1 = 0;
count2 = 0;
count3 = 0;

tic
while count1 < T+Tb
    i = 0;
    while i == 0
        paray = parax + randn(1,Np)*c*sig_r;
        paray_inv = invtrans(paray);
        objy = like(ad,eta,approx,dim,data,paray_inv,filter,N) + prior(paray_inv) + log(obj_jacob(paray_inv));
        i = objy ~= -inf && objy ~= inf && isnan(objy) == 0;
    end  
    
    ratio = min(1,exp(objy-objx));
    if rand <= ratio
        parax = paray;
        parax_inv = paray_inv;
        objx  = objy;
    end
    
    count1 = count1 + 1;
    count2 = count2 + 1;
    count3 = count3 + 1;
   
    para_inv(:,count1) = parax_inv;
    obj(count1) = objx;
    accept(count1) = ratio;
    
    if count3 == Tb
        acc = mean(accept(1:count3));
        if acc > 0.28
            c = c*1.05;
            count1 = 0;
            count2 = 0;
            count3 = 0;
        elseif acc < 0.22
            c = c*0.95;
            count1 = 0;
            count2 = 0;
            count3 = 0;
           % disp(num2str([acc,c]));
        end
    end   
        
%     if count2 == 1e3
%         yycn = [count1/1000,toc/3600,mean(accept(1:count1))];
%         save(filename);
%         display(yycn);
%         count2 = 0;
%     end
end

acc = 1:Np;
act = 1:Np;
for i = 1:Np
   acc(i) = length(unique(para_inv(i,Tb+1:end)))/T;
   acf = autocorr(para_inv(i,Tb+1:end),1e3);
   L = find(abs(acf(2:end))<2/sqrt(T),1);
   if isempty(L) == 1
       L = 1e3;
   end
   act(i) = 1+2*sum(acf(2:L+1));
end
asjd = mean(sum((para_inv(:,Tb+2:end) - para_inv(:,Tb+1:end-1)).^2));
ssjd = asjd*(T-1);

elasp_time = toc;
filename=['.\output\N',num2str(N),'_filter',num2str(filter),'_c',num2str(c),'.mat'];
save(filename);
end