function data = simulate_apf(para,df_t)
T = 100;
Tb = 100;

ad = evalin('base','ad'); 
eta = evalin('base','eta');
approx = evalin('base','approx');
dim = evalin('base','dim');

[nd,ra,pia,gamq,neta,nsig] = ndrv(para,ad,eta,approx);
[pf,~] = polappx(nd,neta,approx);
err = repmat(1./sqrt(gamrnd(df_t/2,2/df_t,1,1+Tb+T)),dim.u,1).*randn(dim.u,1+Tb+T);

[Z,X] = simu_2nd(pf.gx, pf.hx, pf.gxx, pf.hxx, pf.gss, pf.hss, neta, nsig, zeros(1,dim.x), err');
sysm = sysmat(pf,ra,pia,gamq,neta,nsig);  % sysmat will change pf !!
            
Y = sysm.c(:,ones(T,1)) + sysm.zz*Z(Tb+3:end,2:end)' + sysm.zx*X(Tb+3:end,:)';
data = Y';

save('.\An2007_2\data.mat');
end